-- Copyright (2016) sillyfly. Provided under MIT license. See license.txt for details. 

require "defines"
require "math"

local lookahead_start = 2
local lookahead_length = 5
local lookangle = 0.05
local changeangle = 0.01
local scores = {["stone-path"] = 0.9, ["concrete"] = 1}

script.on_event(defines.events.on_tick, function(event)
	-- Process events 10 times per second. 
	if game.tick%6 == 0 then
		local player = game.player
		if player.vehicle and player.vehicle.valid and player.vehicle.type == "car" and player.riding_state.direction == defines.riding.direction.straight and player.vehicle.speed > 0.1 then
			local car = player.vehicle
			local dir = car.orientation
			
			local dirr = dir + lookangle
			local dirl = dir - lookangle
			
			-- scores for straight, right and left
			local ss,sr,sl = 0,0,0
			
			local vs = {math.sin(2*math.pi*dir), -math.cos(2*math.pi*dir)}
			local vr = {math.sin(2*math.pi*dirr), -math.cos(2*math.pi*dirr)}
			local vl = {math.sin(2*math.pi*dirl), -math.cos(2*math.pi*dirl)}
			
			local px = player.position['x'] or player.position[1]
			local py = player.position['y'] or player.position[2]
			local sign = (car.speed > 0 and 1) or -1
			
			local sts = {px, py}
			local str = {px + sign*vs[2]*2, py - sign*vs[1]*2}
			local stl = {px -sign*vs[2]*2, py + sign*vs[1]*2}
			
			for i=lookahead_start,lookahead_start + lookahead_length do
				--player.print(player.surface.get_tile(px + vs[1], py + vs[2]).name)
				local d = i*sign
				local rst = player.surface.get_tile(str[1] + vs[1]*d, str[2] + vs[2]*d).name
				local lst = player.surface.get_tile(stl[1] + vs[1]*d, stl[2] + vs[2]*d).name
				local rt = player.surface.get_tile(px + vr[1]*d, py + vr[2]*d).name
				local lt = player.surface.get_tile(px + vl[1]*d, py + vl[2]*d).name
				
				ss = ss + (((scores[rst] or 0) + (scores[lst] or 0))/2.0)
				sr = sr + (scores[rt] or 0)
				sl = sl + (scores[lt] or 0)
			end
			
			--player.print("x:" .. px .. "->" .. px+vs[1]*(lookahead_start + lookahead_length) .. ", y:" .. py .. "->" .. py+vs[2]*(lookahead_start + lookahead_length))
			--player.print("S: " .. ss .. " R: " .. sr .. " L: " .. sl)
			
			if sr > ss and sr > sl then
				car.orientation  = dir + changeangle*sign
			elseif sl > ss and sl > sr then
				car.orientation = dir - changeangle*sign
			end
			
		end
	end
end)
